<script setup lang="ts">
  import { CustomerAddress } from '@shopware-pwa/types';

  defineEmits<{
    (e: 'create'): void;
    (e: 'set-address', id: string): void;
    (e: 'edit', id: string): void;
  }>();

  const props = defineProps<{
    controller: ReturnType<typeof useModal>;
    type: 'shipping' | 'billing';
    addresses: CustomerAddress[];
    currentAddress: CustomerAddress;
  }>();

  const { t } = useI18n();
  const savedAddresses = computed(() =>
    props.addresses.filter((el) => el.id !== props.currentAddress.id),
  );

  const title = computed(() => {
    return props.type === 'shipping'
      ? t('account.shippingAddresses')
      : t('account.billingAddresses');
  });
</script>

<template>
  <SwModal :modal-title="title" :controller="controller" panel-class="md:min-w-[45rem]">
    <template #body>
      <div class="">
        <p class="mb-4 font-bold">
          {{
            type === 'shipping'
              ? $t('account.currentShippingAddress')
              : $t('account.currentBillingAddress')
          }}
        </p>
        <AccountAddressDetail :address="currentAddress" :show-border="true">
          <template #action>
            <SwButton
              variant="action"
              size="small"
              class="!py-[0.3125rem]"
              @click="$emit('edit', currentAddress.id)"
            >
              <span class="i-sw-solid-pencil-s text-base" />
              <p class="mr-0.5">{{ $t('edit') }}</p>
            </SwButton>
          </template>
        </AccountAddressDetail>
      </div>

      <div class="mt-6">
        <div class="mb-4 flex items-center justify-between">
          <p v-if="savedAddresses.length" class="font-bold">{{ $t('account.savedAddresses') }}</p>
          <SwButton variant="action" size="medium" @click="$emit('create')">
            <span class="i-sw-solid-plus-circle text-base" />
            <p class="mr-0.5">{{ $t('account.addNewAddress') }}</p>
          </SwButton>
        </div>

        <div class="flex flex-col gap-4">
          <AccountAddressDetail
            v-for="address in savedAddresses"
            :key="address.id"
            :address="address"
            :show-border="true"
          >
            <template #action>
              <SwButton
                variant="action"
                size="small"
                class="!py-[0.3125rem]"
                @click="$emit('edit', address.id)"
              >
                <span class="i-sw-solid-pencil-s text-base" />
                <p class="mr-0.5">{{ $t('edit') }}</p>
              </SwButton>
            </template>

            <template #default>
              <SwButton class="mt-3 !py-[0.5625rem]" @click="$emit('set-address', address.id)">
                {{
                  type === 'shipping'
                    ? $t('account.useAsShippingAddress')
                    : $t('account.useAsBillingAddress')
                }}
              </SwButton>
            </template>
          </AccountAddressDetail>
        </div>
      </div>
    </template>

    <template #footer>
      <SwButton size="large" class="!py-[0.6875rem]" @click="controller.close">
        {{ $t('done') }}
      </SwButton>
    </template>
  </SwModal>
</template>
